<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Louvain Algorithm: src/graph.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Louvain Algorithm
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">graph.c File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;stdio.h&gt;</code><br />
<code>#include &lt;stdlib.h&gt;</code><br />
<code>#include &lt;string.h&gt;</code><br />
<code>#include &quot;<a class="el" href="graph_8h_source.html">graph.h</a>&quot;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for graph.c:</div>
<div class="dyncontent">
<div class="center"><img src="graph_8c__incl.png" border="0" usemap="#src_2graph_8c" alt=""/></div>
<map name="src_2graph_8c" id="src_2graph_8c">
<area shape="rect" id="node5" href="graph_8h.html" title="graph.h" alt="" coords="269,80,334,107"/>
</map>
</div>
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a5e16a2fa4e5144aa18b57a3a8dff4c2c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8c.html#a5e16a2fa4e5144aa18b57a3a8dff4c2c">add_head</a> (<a class="el" href="structgnode__t.html">gnode_t</a> **head, int val, int weight)</td></tr>
<tr class="separator:a5e16a2fa4e5144aa18b57a3a8dff4c2c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a790a220324e80f89694c91b8d928d840"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8c.html#a790a220324e80f89694c91b8d928d840">remove_entry</a> (<a class="el" href="structgnode__t.html">gnode_t</a> **list_head, int target)</td></tr>
<tr class="separator:a790a220324e80f89694c91b8d928d840"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa4a2c58cf35124509c40dea83129ac93"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8c.html#aa4a2c58cf35124509c40dea83129ac93">create_graph</a> (<a class="el" href="structedge__t.html">edge_t</a> *edges, int n)</td></tr>
<tr class="separator:aa4a2c58cf35124509c40dea83129ac93"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a16b6212a05e5662ccfd37199d50c637a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8c.html#a16b6212a05e5662ccfd37199d50c637a">num_edges</a> (<a class="el" href="structgraph__t.html">graph_t</a> *g)</td></tr>
<tr class="separator:a16b6212a05e5662ccfd37199d50c637a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa06aa604e7ce71847f52d0225ecc43d0"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8c.html#aa06aa604e7ce71847f52d0225ecc43d0">num_vertices</a> (<a class="el" href="structgraph__t.html">graph_t</a> *g)</td></tr>
<tr class="separator:aa06aa604e7ce71847f52d0225ecc43d0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9d32135f75dc83ddf7f04ebedc915239"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8c.html#a9d32135f75dc83ddf7f04ebedc915239">degree</a> (<a class="el" href="structgraph__t.html">graph_t</a> *g, int node_id)</td></tr>
<tr class="separator:a9d32135f75dc83ddf7f04ebedc915239"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a060b402e39855ced428216b327b030a5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8c.html#a060b402e39855ced428216b327b030a5">add_edge</a> (<a class="el" href="structgraph__t.html">graph_t</a> *g, <a class="el" href="structedge__t.html">edge_t</a> e)</td></tr>
<tr class="separator:a060b402e39855ced428216b327b030a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a564fd8433c014fded5dfe9b0d5f9aa30"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8c.html#a564fd8433c014fded5dfe9b0d5f9aa30">remove_edge</a> (<a class="el" href="structgraph__t.html">graph_t</a> *g, <a class="el" href="structedge__t.html">edge_t</a> e)</td></tr>
<tr class="separator:a564fd8433c014fded5dfe9b0d5f9aa30"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a151f5b250afc78268f7034af24a8f40f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8c.html#a151f5b250afc78268f7034af24a8f40f">clean_graph</a> (<a class="el" href="structgraph__t.html">graph_t</a> *g)</td></tr>
<tr class="separator:a151f5b250afc78268f7034af24a8f40f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeb9fa7dddb67352ac4e1560d95b08024"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8c.html#aeb9fa7dddb67352ac4e1560d95b08024">print_graph</a> (<a class="el" href="structgraph__t.html">graph_t</a> *g)</td></tr>
<tr class="separator:aeb9fa7dddb67352ac4e1560d95b08024"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Function Documentation</h2>
<a id="a060b402e39855ced428216b327b030a5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a060b402e39855ced428216b327b030a5">&#9670;&nbsp;</a></span>add_edge()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void add_edge </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td>
          <td class="paramname"><em>g</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structedge__t.html">edge_t</a>&#160;</td>
          <td class="paramname"><em>e</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to insert a new edge in a given graph. It has to add the edge both in the source vertex and in the destination edge's list. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">g</td><td>The graph one wants to modify. </td></tr>
    <tr><td class="paramname">e</td><td>The edge that one wants to add. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a5e16a2fa4e5144aa18b57a3a8dff4c2c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5e16a2fa4e5144aa18b57a3a8dff4c2c">&#9670;&nbsp;</a></span>add_head()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void add_head </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structgnode__t.html">gnode_t</a> **&#160;</td>
          <td class="paramname"><em>head</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>val</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>weight</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Utility function to add a new node to the head of the list. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">head</td><td>the list head address. </td></tr>
    <tr><td class="paramname">val</td><td>The value of the node. </td></tr>
    <tr><td class="paramname">weight</td><td>The weight of the link. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a151f5b250afc78268f7034af24a8f40f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a151f5b250afc78268f7034af24a8f40f">&#9670;&nbsp;</a></span>clean_graph()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void clean_graph </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td>
          <td class="paramname"><em>g</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to free all allocated memory for the graph. It iteratively frees memory for all edges, then for all vertices and then for the graph itself. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">g</td><td>The graph one wants to remove. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aa4a2c58cf35124509c40dea83129ac93"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa4a2c58cf35124509c40dea83129ac93">&#9670;&nbsp;</a></span>create_graph()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structgraph__t.html">graph_t</a>* create_graph </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structedge__t.html">edge_t</a> *&#160;</td>
          <td class="paramname"><em>edges</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>n</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>A function to create a graph starting from the edges in format source - destination. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">edges</td><td>The array of edges of the graph you want to create. </td></tr>
    <tr><td class="paramname">n</td><td>The number of edges contained in the array. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the graph. </dd></dl>

</div>
</div>
<a id="a9d32135f75dc83ddf7f04ebedc915239"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9d32135f75dc83ddf7f04ebedc915239">&#9670;&nbsp;</a></span>degree()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int degree </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td>
          <td class="paramname"><em>g</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>node_id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to calculate the weighted degree of a node.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">g</td><td>The pointer to the graph which contains the node. </td></tr>
    <tr><td class="paramname">node_id</td><td>The index of the node. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The weighted degree of the given node. </dd></dl>

</div>
</div>
<a id="a16b6212a05e5662ccfd37199d50c637a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a16b6212a05e5662ccfd37199d50c637a">&#9670;&nbsp;</a></span>num_edges()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int num_edges </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td>
          <td class="paramname"><em>g</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to return the number of edges in the graph. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">g</td><td>The graph one wants to know the number of edges. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The number of edges. </dd></dl>

</div>
</div>
<a id="aa06aa604e7ce71847f52d0225ecc43d0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa06aa604e7ce71847f52d0225ecc43d0">&#9670;&nbsp;</a></span>num_vertices()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int num_vertices </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td>
          <td class="paramname"><em>g</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to return the number of vertices in the graph. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">g</td><td>The graph one wants to know the number of vertices. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The number of vertices. </dd></dl>

</div>
</div>
<a id="aeb9fa7dddb67352ac4e1560d95b08024"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aeb9fa7dddb67352ac4e1560d95b08024">&#9670;&nbsp;</a></span>print_graph()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void print_graph </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td>
          <td class="paramname"><em>g</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to print to stdout the adjacency list of every node in the graph. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">g</td><td>the graph one wants to print </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a564fd8433c014fded5dfe9b0d5f9aa30"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a564fd8433c014fded5dfe9b0d5f9aa30">&#9670;&nbsp;</a></span>remove_edge()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void remove_edge </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td>
          <td class="paramname"><em>g</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structedge__t.html">edge_t</a>&#160;</td>
          <td class="paramname"><em>e</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to remove an edge from a given graph. It removes the edge from both the vertices' lists that were involved in the connection. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">g</td><td>The origin graph. </td></tr>
    <tr><td class="paramname">e</td><td>The edge one wants to remove. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a790a220324e80f89694c91b8d928d840"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a790a220324e80f89694c91b8d928d840">&#9670;&nbsp;</a></span>remove_entry()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int remove_entry </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structgnode__t.html">gnode_t</a> **&#160;</td>
          <td class="paramname"><em>list_head</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>target</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Utility function to remove an entry from an adjacency list. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">list_head</td><td>The head of the adjacency list. </td></tr>
    <tr><td class="paramname">target</td><td>The entry id to remove. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>0 if the removal didn't end well, 1 if the function finished correctly </dd></dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
